.TH layout 1 "25 April 1991"
.fi
.SH NAME
Save window layout between invocations
.SH DESCRIPTION
Executing this macro causes a flag to be set so that when you
exit CRISP, it will remember the buffers you were editing and the
screen layout. When you next run CRISP the screen will look exactly
the same as when you last exited.
.P
This macro works by creating a file called '\f(HB.crstate\fR' in the
current directory. This means that saving the window layout can be
enabled or disabled on a per directory basis. This was done to
avoid polluting users directories with individual state files.
Having a state file per directory is also useful when you keep shifting work
between different projects -- you don't have to lose all you're
state information just because you temporarily edit other files.
This macro has a separate state file rather than keeping one in the
users home directory to avoid slowing down startup by having to parse
a large file.
.P
In order to turn off state file processing, it is simply necessary to
delete the \f(HB.crstate\fR file in the current directory.
.P
Even if you do not want window layout information saved on a per
directory basis, CRISP will remember the last file you edited in
the current directory. This information is stored in the file
~/.crisp. It may be worth truncating this file every so often as
it can grow quite large and slow down startup time.
.P
When starting up, CRISP verifies that the current screen size or window size
is the same as that recorded in the state file. If it is not, then the
state file is ignored. This is done to avoid problems with impossible
or implausible screen layouts when moving from large to smaller windows.
.SH MENU/KEYS
This macro can be accessed from the CRISP features menu.

