/*
**	This is the default terminal description for QNX style terminals.
**
**	robo - March 1993
*/
# include	"tty.h"

void		main()
{

	/***********************************************/
	/*   Set   characters   used   for   extended  */
	/*   graphics support when drawing windows.    */
	/***********************************************/
	set_term_characters(
		0xd5,		/* Top left of window.			   */
		0xb8,		/* Top right of window.			   */
		0xd4,		/* Bottom left of window.		   */
		0xbe,		/* Bottom right of window.		   */
		0xb3,		/* Vertical bar for window sides.	   */
		0xcd,		/* Top and bottom horizontal bar for window.*/
		0xd1,		/* Top join.				    */
		0xcf,		/* Bottom join.				    */
		0xd8,		/* Window 4-way intersection.		    */
		0xb5,		/* Left hand join.			    */
		0xc6		/* Right hand join.			    */
		);

	/***********************************************/
	/*   Define   escape   sequences   used   for  */
	/*   special optimisations on output.	       */
	/***********************************************/
	set_term_features(
		NULL,		/* Sequence to clear 'n' spaces.	    */
		NULL,		/* Sequence to print characters with top    */
		     		/* bit set.				    */
		NULL,		/* Insert-mode cursor.			    */
		NULL,		/* Overwrite-mode cursor.		    */
		NULL,		/* Insert-mode cursor (on virtual space).   */
		NULL,		/* Overwrite-mode cursor (on virtual space).*/
		NULL,		/* Escape sequence to repeat last character.*/
		NULL,		/* Print ESCAPE character graphically.	    */
		FALSE,		/* ESC [0m resets color.		    */
		FALSE		/* Terminal does support color.	    */
		);

	/***********************************************/
	/*   Define  keyboard  layout  for  non-ascii  */
	/*   characters.  These  can only be used for  */
	/*   the console.			 			       */
	/***********************************************/
	set_term_keyboard(
		F1_F12, quote_list(
			"\xFF\x81",	"\xFF\x82",	"\xFF\x83",	"\xFF\x84",	"\xFF\x85",
			"\xFF\x86",	"\xFF\x87",	"\xFF\x88",	"\xFF\x89",	"\xFF\x8A",
			"\xFF\xAE",	"\xFF\xAF" ),

		SHIFT_F1_F12, quote_list(
			"\xFF\x8B",	"\xFF\x8C",	"\xFF\x8D",	"\xFF\x8E",	"\xFF\x8F",
			"\xFF\x90",	"\xFF\x91",	"\xFF\x92",	"\xFF\x93",	"\xFF\x94",
			"\xFF\xDB",	"\xFF\xDC" ),

		CTRL_F1_F12, quote_list(
			"\xFF\x95",	"\xFF\x96",	"\xFF\x97",	"\xFF\x98",	"\xFF\x99",
			"\xFF\x9A",	"\xFF\x9B",	"\xFF\x9C",	"\xFF\x9D",	"\xFF\x9E",
			"\xFF\xBE",	"\xFF\xBF" ),

		ALT_A_Z, quote_list(
			"\xFF\xE1",	"\xFF\xE2",	"\xFF\xE3",	"\xFF\xE4",	"\xFF\xE5", /* alt a-e */
			"\xFF\xE6",	"\xFF\xE7",	"\xFF\xE8",	"\xFF\xE9",	"\xFF\xEA", /* alt f-j */
			"\xFF\xEB",	"\xFF\xEC",	"\xFF\xED",	"\xFF\xEE",	"\xFF\xEF", /* alt k-o */
			"\xFF\xF0",	"\xFF\xF1",	"\xFF\xF2",	"\xFF\xF3",	"\xFF\xF4", /* alt p-t */
			"\xFF\xF5",	"\xFF\xF6",	"\xFF\xF7",	"\xFF\xF8",	"\xFF\xF9", /* alt u-y */
			"\xFF\xFA" ),

		KEYPAD_0_9, quote_list(
			"\xFF\xAB",	"\xFF\xA8",	"\xFF\xA9",	"\xFF\xAA",	"\xFF\xA4",
			"\xFF\xA5",	"\xFF\xA6",	"\xFF\xA0",	"\xFF\xA1",	"\xFF\xA2",
			"\xFF\xAC" ),

		CTRL_KEYPAD_0_9, quote_list(
			"\xFF\xBB",	"\xFF\xB8",	"\xFF\xB9",	"\xFF\xBA",	"\xFF\xB4",
			"\xFF\xB5",	"\xFF\xB6",	"\xFF\xB0",	"\xFF\xB1",	"\xFF\xB2",
			"\xFF\xBC" ),

		ALT_0_9, quote_list(
			"\xFF\xCB",	"\xFF\xC8",	"\xFF\xC9",	"\xFF\xCA",	"\xFF\xC4",
			"\xFF\xC5",	"\xFF\xC6",	"\xFF\xC0",	"\xFF\xC1",	"\xFF\xC2",
			"\xFF\xCC" ),

		CTRL_H,		"\x7f",
		CUT,		"\xFF\xA3",
		COPY,		"\xFF\xA7",
		BACK_TAB,	"\xFF\x80"
		);
	
}
